<template>
    <div>
        <div class="wrap">
            <p class="title">
                Degree
            </p>
            <div
                v-for="item in [-90,-60,-30,0,30,60,90]"
                :key="item"
                class="button"
                :class="{'-active':tail.rotate === item}"
                @click="tail.rotate = item"
            >
                {{ item }}
            </div>
        </div>
        <div class="wrap">
            <p class="title">
                counts
            </p>
            <div
                v-for="item in [2,4,8,16,64]"
                :key="item"
                :class="{'-active':counts === item}"
                class="button"
                @click="counts = item"
            >
                {{ item }}
            </div>
        </div>
        <div class="wrap">
            <p class="title">
                height
            </p>
            <div
                v-for="item in [10,20,50,100,150]"
                :key="item"
                :class="{'-active':height === item}"
                class="button"
                @click="height = item"
            >
                {{ item }}
            </div>
        </div>
        <svg width="100%" height="100%" viewBox="0 0 1000 1000" xmlns="http://www.w3.org/2000/svg">
            <rect x="0" y="0" width="100%" height="100%" stroke="red" fill="white" />
            <!-- <g transform="translate(450 0)">
                <g :transform="transform1">
                    <rect x="0" y="0" width="10" height="100" stroke="black" fill="white" />
                    <g :transform="transform2">
                        <rect x="0" y="0" width="10" height="100" stroke="black" fill="white" />
                        <g :transform="transform3">
                            <rect x="0" y="0" width="10" height="100" stroke="black" fill="white" />
                        </g>
                    </g>
                </g>
            </g> -->
            <g transform="translate(500 100) rotate(16)">
                <tail-item :level="counts" :option="tail" :height="height" />
            </g>
            <text x="475" y="20">deg: {{ tail.rotate }}</text>
            <text x="475" y="40">count: {{ counts }}</text>
            <text x="475" y="60">height: {{ height }}</text>
        </svg>
    </div>
</template>

<script>
// @ is an alias to /src
import gsap from 'gsap'
import _ from 'lodash'
import tailItem from '../components/tail-item'

export default {
    components: {
        tailItem,
    },
    data() {
        return {
            counts: 5,
            height: 100,
            tail: {
                duration: 2,
                rotate: -16,
                delay: 0,
            },
        }
    },
    computed: {
        transform1() {
            if (this.one) {
                const { x, y, rotate } = this.one
                return `translate(${x} ${y}) rotate(${rotate})`
            }
            return 'translate(0 0)'
        },
        transform2() {
            if (this.two) {
                const { x, y, rotate } = this.two
                return `translate(${x} ${y}) rotate(${rotate})`
            }
            return 'translate(0 0)'
        },
        transform3() {
            if (this.three) {
                const { x, y, rotate } = this.three
                return `translate(${x} ${y}) rotate(${rotate})`
            }
            return 'translate(0 0)'
        },
    },
    mounted() {
        // this.initObject()
        // this.action({ rotate: 40, duration: 1, ease: 'none' })
    },
    methods: {
        initObject() {
            this.one = { x: 0, y: 0, rotate: 0 }
            this.two = { x: 0, y: 100, rotate: 0 }
            this.three = { x: 0, y: 100, rotate: 0 }
        },
        weakenOption(option) {
            return _.transform(option, (result, value, key) => {
                if (typeof value === 'number') {
                    result[key] = value * 0.5
                } else {
                    result[key] = value
                }
            }, {})
        },
        action(option) {
            const fisrt_act = gsap.to(this.one, option)
            const second_act = (option) => {
                console.log(option)
                const tween = gsap.to(this.two, option)
                tween.eventCallback('onComplete', third_act, [this.weakenOption(option)])
            }
            const third_act = (option) => {
                console.log(option)
                gsap.to(this.three, option)
            }
            fisrt_act.eventCallback('onComplete', second_act, [this.weakenOption(option)])
        },
    },
}
</script>
<style lang="scss">
    .wrap {
        display: flex;
        margin-bottom: 10px;
    }
    .button {
        width: 50px;
        height: 40px;
        margin-right: 20px;
        line-height: 40px;
        border: 1px solid black;
        border-radius: 10px;
        cursor: pointer;
        transition: opacity 0.3s;
        &.-active,&:hover {
            opacity: 0.7;
            background: black;
            color: white;
        }
    }
    .title {
        line-height: 40px;
        font-size: 24px;
        margin-right: 20px;
    }
</style>